#include "testbase.h"

#ifndef NDEBUG
static const char testplugin_path[] = "./testplugin/Debug/testplugin.dll";
#else
static const char testplugin_path[] = "./testplugin/Release/testplugin.dll";
#endif


void main()
{
	// Load the factory from a plugin library.
	utility::factory::handle fh = utility::load_factory(testplugin_path);
	if (!fh.valid() || (fh->size() <= 0))
	{
		printf("Failed to load plugin library: %s\n", testplugin_path);
		return;
	}

	// Create a plugin from the factory.
	utility::plugin* p = fh->create_plugin(0);

	// Cast the plugin to the required type.
	testbase* testp = utility::plugin_cast<testbase*>(p);
	if (testp == 0)
	{
		printf("Failed to create test plugin\n");
		return;
	}

	// Use the plugin.
	testp->print_hello();

	// Destroy the plugin.
	testp->destroy();

	// The factory handle gets deconstructed here, and implicitly unloads the library.
}